Bug 484158 - FEAT: feature request. disable iostat collection in gendisk
FEAT: feature request. disable iostat collection in gendisk
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: kernel (Show other bugs)
5.3
All Linux
low Severity high
: rc
: 5.4
Assigned To: Jerome Marchand
Red Hat Kernel QE team
: ZStream
Depends On:
Blocks: 488544 646908 651809
  Show dependency treegraph
 
Reported: 2009-02-04 20:46 EST by Chinang Ma
Modified: 2010-11-10 06:11 EST (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
: 488544 646908 (view as bug list)
Environment:
Last Closed: 2009-09-02 04:58:50 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
control iostat with sysfs file (6.33 KB, patch)
2009-02-19 14:45 EST, Chinang Ma
no flags Details | Diff

  None (edit)
Description Chinang Ma 2009-02-04 20:46:50 EST
Description of problem:
RHEL 5.3 have partition io stats enabled in the kernel (as seen in iostats -x) and caused performance regression in OLTP workload.

Version-Release number of selected component (if applicable):
RHEL 5.3

How reproducible:
Test with OLTP workload (TPC-C) in Quad-core Xeon DP system. ~ 1% performance regression.

Steps to Reproduce:
Run OLTP workload  in RHEL5.2 (TPC-C) and collect profile. run 5.3 with same workload. 1.3% cycles was attributed to get_partstat()
1.
2.
3.
  
Actual results:


Expected results:


Additional info:
Feature request. please backport 2.6-git iostat enable/disable queue knob to EL 5.4. this expose a sysfs block device switch(/sys/block/sd<xx>/queue/iostat) that disable iostat collection in kernel.
locations:

git://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux-2.6
 
commit bc58ba9468d94d62c56ab9b47173583ec140b165
Author: Jens Axboe <jens.axboe@oracle.com>
Date:   Fri Jan 23 10:54:44 2009 +0100

    block: add sysfs file for controlling io stats accounting

    This allows us to turn off disk stat accounting completely, for the cases
    where the 0.5-1% reduction in system time is important.

    Signed-off-by: Jens Axboe <jens.axboe@oracle.com>
Comment 1 Chinang Ma 2009-02-19 14:45:53 EST
Created attachment 332619 [details]
control iostat with sysfs file
Comment 2 Chinang Ma 2009-02-19 14:48:07 EST
RHEL 5.3 has 1.5% OLTP performance regression compare to RHEL5.2. We  back-ported Jens Axboe's iostat control patch to RHEL5.2. When iostats was disable using sysfs file, we recovered 1.2% of the regression.
Comment 3 Linda Wang 2009-03-04 13:49:53 EST
we are looking into getting this patch into 5.4. fyi..
Comment 4 Jerome Marchand 2009-03-05 07:55:42 EST
The patch "block: fix oops in blk_queue_io_stat()" (git# fb8ec18c316d869271137c97320dbfd2def56569) has to be backported too in order to avoid NULL pointer dereferencing.
Comment 5 Jerome Marchand 2009-03-09 06:07:22 EDT
Upstream patch is buggy. It doesn't turn off accounting completely and that may leave io stats in an inconsistent state. I'm working on its correction.
Comment 7 Don Zickus 2009-05-12 13:41:05 EDT
in kernel-2.6.18-146.el5
You can download this test kernel from http://people.redhat.com/dzickus/el5

Please do NOT transition this bugzilla state to VERIFIED until our QE team
has sent specific instructions indicating when to do so.  However feel free
to provide a comment indicating that this fix has been verified.
Comment 9 Chris Ward 2009-07-03 14:23:37 EDT
~~ Attention - RHEL 5.4 Beta Released! ~~

RHEL 5.4 Beta has been released! There should be a fix present in the Beta release that addresses this particular request. Please test and report back results here, at your earliest convenience. RHEL 5.4 General Availability release is just around the corner!

If you encounter any issues while testing Beta, please describe the issues you have encountered and set the bug into NEED_INFO. If you encounter new issues, please clone this bug to open a new issue and request it be reviewed for inclusion in RHEL 5.4 or a later update, if it is not of urgent severity.

Please do not flip the bug status to VERIFIED. Only post your verification results, and if available, update Verified field with the appropriate value.

Questions can be posted to this bug or your customer or partner representative.
Comment 10 Chinang Ma 2009-07-07 14:56:24 EDT
I have verified that RHEL 5.4 beta (2.6.18-155.el5
) has iostat disabling option avaliable under /sys/block/<device>/queue/iostats. Tested with OLTP workload on a Nehalem 2 sockets server with 16 logical CPUs.  We saw ~4% increase in performance when iostats is disabled (changed from 1 to 0 ) . This made RHEL 5.4 OLTP peroformance on par with RHEL 5.2.
Comment 12 errata-xmlrpc 2009-09-02 04:58:50 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2009-1243.html

Note You need to log in before you can comment on or make changes to this bug.